<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1 shrink-to-fit=no">
	<title>Boostrap Flex</title>
	<!-- Boostrap CSS -->
	<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/css/bootstrap.min.css" integrity="sha384-zCbKRCUGaJDkqS1kPbPd7TveP5iyJE0EjAuZQTgFLD2ylzuqKfdKlfG/eSrtxUkn" crossorigin="anonymous">
	<!-- External Custom CSS -->
	<link rel="stylesheet" type="text/css" href="./index.css">
</head>
<body>
	<h1 class="text-center mt-5">Bootstrap Flex</h1>

<!-- Flexbox is used to manipulate and layout elements. This can be done exclusively using css. However, with bootstrap, we can apply flex faster and easier. We only need to add d-flex as a class for our parent container to make it's children as flex items.
Flex items/children are not exactly elements that we can manipulate with height and width.
Flex items by default are arranged in row. Direction of flex items are flex-row, flex-reverse, flex-column, flex-column-reverse.
Flex-row default starts from left to right.
Flex column will arrange items from top to bottomw in a column. -->

<!-- Flex row Default -->
<h3 class="text-center my-3">Flex Row</h3>
<div class="bg-dark d-flex mb-4">
	<div class="bg-primary p-2">Flex Item 1</div>
	<div class="bg-danger p-2">Flex item 2</div>
	<div class="bg-success p-2">Flex item 3</div>
</div>

<!-- Flex Reverse -->
<h3 class="text-center my-3">Flex Row</h3>
<div class="bg-dark d-flex flex-row-reverse mb-4">
	<div class="bg-primary p-2">Flex Item 1</div>
	<div class="bg-danger p-2">Flex item 2</div>
	<div class="bg-success p-2">Flex item 3</div>
</div>

<!-- Flex Column -->
<h3 class="text-center my-3">Flex Column</h3>
<div class="bg-dark d-flex flex-column mb-4">
	<div class="bg-primary p-2">Flex Item 1</div>
	<div class="bg-danger p-2">Flex item 2</div>
	<div class="bg-success p-2">Flex item 3</div>
</div>

<!-- Span as Flex Column Items -->
<h3 class="text-center my-3">Span as Flex Column Items</h3>
<div class="bg-dark d-flex flex-column mb-4">
	<div class="bg-primary p-2">Span Flex Item 1</div>
	<div class="bg-danger p-2">Span Flex item 2</div>
	<div class="bg-success p-2">Span Flex item 3</div>
</div>

<!-- Justify Content -->
<!-- Allow us to manipulate and change the horizontal alignment of flex row items, however for flex column items, because justify-content manipulate the vertical alignment  -->
<h2 class="text-center my-5">Justify Content</h2>
<h3 class="text-center my-5">Justify Content Start</h3>
<div class="bg-dark d-flex flex-row justify-content-start mb-4">
	<div class="bg-warning p-2">Flex Item 1</div>
	<div class="bg-danger p-2">Flex item 2</div>
	<div class="bg-info p-2">Flex item 3</div>
</div>

<!-- Mini Activity -->
<h3 class="text-center my-5">Mini Activity</h3>

<div class="bg-dark d-flex flex-row justify-content-center align-items-center mb-4" style="height: 50vh">
	 	<div class="bg-warning p-2">Flex Item 1</div>
	 	<div class="bg-danger p-2">Flex Item 2</div>
	 	<div class="bg-info p-2">Flex Item 3</div>
	 </div>


<div class="bg-dark d-flex flex-row justify-content-around align-items-center mb-4" style="height: 50vh">
	 	<div class="bg-warning p-2">Flex Item 1</div>
	 	<div class="bg-danger p-2">Flex Item 2</div>
	 	<div class="bg-info p-2">Flex Item 3</div>
	 </div>	

<!-- Mini Activity -->
<h3 class="text-center my-5">Mini Activity</h3>
<div class="bg-dark d-flex flex-column justify-content-end align-items-start mb-4" style="height: 50vh">
	 	<div class="bg-warning p-2" style="width: 20%;">Flex Item 1</div>
	 	<div class="bg-danger p-2" style="width: 20%;">Flex Item 2</div>
	 	<div class="bg-info p-2" style="width: 20%;">Flex Item 3</div>
	 </div>

<div class="bg-dark d-flex flex-column justify-content-start align-items-end mb-4" style="height: 50vh">
	 	<div class="bg-warning p-2" style="width: 20%;">Flex Item 1</div>
	 	<div class="bg-danger p-2" style="width: 20%;">Flex Item 2</div>
	 	<div class="bg-info p-2" style="width: 20%;">Flex Item 3</div>
	 </div>

<!-- Flex Wrap -->

<h3 class="text-center my-5">Flex Wrap</h3>
<div class="bg-dark d-flex flex-row flex-wrap mb-4">
	 	<div class="bg-primary p-2">Flex Item 1</div>
	 	<div class="bg-danger p-2">Flex Item 2</div>
	 	<div class="bg-success p-2">Flex Item 3</div>
	 	<div class="bg-warning p-2">Flex Item 1</div>
	 	<div class="bg-info p-2">Flex Item 2</div>
	 	<div class="bg-primary p-2">Flex Item 3</div>
	 	<div class="bg-success p-2">Flex Item 1</div>
	 	<div class="bg-danger p-2">Flex Item 2</div>
	 	<div class="bg-warning p-2">Flex Item 3</div>
	 </div>



<script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/js/bootstrap.bundle.min.js" integrity="sha384-fQybjgWLrvvRgtW6bFlB7jaZrFsaBXjsOMm/tB9LTS58ONXgqbR9W8oWht/amnpF" crossorigin="anonymous"></script>
</body>
</html>